// 6.05.2007   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                          BrainTrend1StopLine.mq4 |          
//|                                     BrainTrading Inc. System 7.0 |
//|                                      http://www.braintrading.com |      
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "BrainTrading Inc. System 7.0"
#property link "http://www.braintrading.com"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
//---- input parameters
extern int CountBars=500;
extern int    Price          = 0;    //Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int    Order          = 3;    //Filter Order: 1-1st,2-2nd,3-3rd,4-4th
extern int    FilterPeriod   = 10;    //Filter Period 
extern int    PreSmooth      = 1;    //Pre-smoothing period
extern int    PreSmoothMode  = 0;    //Pre-smoothing MA Mode: 0-SMA,1-EMA,2-SMMA,3-LWMA
extern double PctFilter      = 0.0;  //Dynamic filter in decimal(multiplier for StdDev)


//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
//----
int f,x1,x2,value11,limit,p;
double val1,val2,val3,r,s,d;
double value2,value3,value4,value5,value6,Range,range1;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int init()
{
//---- indicator 0
SetIndexStyle(0,DRAW_LINE);
SetIndexBuffer(0,Ind_Buffer1);
//---- indicator 1
SetIndexStyle(1,DRAW_LINE);
SetIndexBuffer(1,Ind_Buffer2);
//----
string short_name;
short_name="BrainTrend1StopLine";
IndicatorShortName(short_name);
SetIndexLabel(0,""+short_name+"_SELL");
SetIndexLabel(1,""+short_name+"_BUY" );
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//----
s=1.5; d=2.3; f=7; value11 = 9; x1 = 53; x2 = 47;
//----
return(0);
}
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start()
{
double CloseVal, CloseVal2, HighVal, LowVal;
int shift,counted_bars=IndicatorCounted();
//---- 
if (Bars < 11)return(0);
if (CountBars > Bars-1-11)CountBars=Bars-1-11;
//----  
limit = CountBars; p=0;//-counted_bars-20
//----  
shift=limit;
//---- 
while(shift>=0)
{

Range  = iATR(NULL,0,f, shift) / d;
range1 = iATR(NULL,0,10,shift) * s;
value2 = iStochastic(NULL,0,value11,value11,1,0,0,0,shift);

CloseVal  = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",Price,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift),Digits);
CloseVal2 = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",Price,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift + 2),Digits);
HighVal = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",2,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift),Digits);
LowVal  = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",3,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift),Digits);

val1 = 0;
val2 = 0;
val3 = MathAbs(CloseVal - CloseVal2);
if (value2 < x2 && val3 > Range && p != 1 )
{
value3 = HighVal + range1 / 4;
val1 = value3;
p = 1;
r = val1;
Ind_Buffer1[shift]=val1;
Ind_Buffer2[shift]=EMPTY_VALUE;
}
if (value2 > x1 && val3 > Range&& p != 2 )
{
value3 = LowVal - range1 / 4;
val2 = value3;
p = 2;
r = val2;
Ind_Buffer1[shift]=EMPTY_VALUE;
Ind_Buffer2[shift]=val2;
}
value4 = HighVal + range1;
value5 = LowVal - range1;
if (val1 == 0 && val2 == 0 && p == 1)
{
if (value4 < r)
{
r = value4;
Ind_Buffer1[shift]=r;
Ind_Buffer2[shift]=EMPTY_VALUE;
}
else
{
//r = r;
Ind_Buffer1[shift]=r;
Ind_Buffer2[shift]=EMPTY_VALUE;
}
}
if (val1 == 0 && val2 == 0 && p == 2 )
{
if (value5 > r )
{
r = value5;
Ind_Buffer1[shift]=EMPTY_VALUE;
Ind_Buffer2[shift]=r;
}
else
{
//r = r;
Ind_Buffer1[shift]=EMPTY_VALUE;
Ind_Buffer2[shift]=r;
}
}
shift--;
}
//----
return(0);
}
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 